<?php
/* -*- tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
# ***** BEGIN LICENSE BLOCK *****
# This file is part of Plume CMS, a website management application.
# Copyright (C) 2001-2005 Loic d'Anterroches and contributors.
#
# Plume CMS is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# Plume CMS is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
# ***** END LICENSE BLOCK ***** */



class Error404
{
    /**
     * Action to display the 404 error.
     *
     * @param string Server query string
     * @return int Success code
     */
    function action($query)
    {
        config::setVar('category_page', 1);
        $GLOBALS['_PX_render']['last'] = '';
        $last =& $GLOBALS['_PX_render']['last']; 
        $GLOBALS['_PX_render']['website'] = '';
        $website =& $GLOBALS['_PX_render']['website']; 
        $GLOBALS['_PX_render']['res'] = '';
        $res =& $GLOBALS['_PX_render']['res']; 

        // Parse query string to find the matching article
        $con =& pxDBConnect();
        $s = new Search($con, config::f('website_id'));

        $query = preg_replace('#^(/error404)#', '', $query);
        config::setVar('query_string', Error404::parseQueryString($query));

        $sql = $s->create_search_query_string(config::f('query_string'));
        $extra = ' AND '.$con->pfx.'resources.publicationdate <= '
            .date::stamp().' AND '.$con->pfx.'resources.enddate >= '
            .date::stamp().' AND '.$con->pfx.'resources.status = '
            .PX_RESOURCE_STATUS_VALIDE;
        $sql = sprintf($sql, $extra);

        if (($res = $con->select($sql, 'ResourceSet')) === false) {
            $GLOBALS['_PX_render']['error']->setError('MySQL: '
                                                      .$con->error(), 500);
            return 404;
        }

        $GLOBALS['_PX_render']['res']->autoSave(array('score', 'total'));
        $GLOBALS['_PX_render']['website'] = FrontEnd::getWebsite();

        header('Status: 404 Not Found');
        header(FrontEnd::getHeader('404.php'));
        // Load the template
        include config::f('manager_path').'/templates/'
            .config::f('theme_id').'/404.php';
        return 200;
    }

    /**
     * Parse query string.
     *
     * @param string Query string
     * @return string Clean query string
     */
    function parseQueryString($query)
    {
        $clean = '';
        $query = Search::clean_string($query);
        $words = Search::explode_in_words($query, true);
        foreach ($words as $k => $v) {
            $clean .= $k.' ';
        }
        return trim($clean);
    }

}

?>