<?php
/* -*- tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
# ***** BEGIN LICENSE BLOCK *****
# This file is part of Plume CMS, a website management application.
# Copyright (C) 2001-2005 Loic d'Anterroches and contributors.
#
# Plume CMS is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# Plume CMS is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
# ***** END LICENSE BLOCK ***** */



class RSS
{
    /**
     * Action to display the RSS feeds.
     *
     * @param string Server query string
     * @return int Success code
     */
    function action($query)
    {
        Hook::register('onInitTemplate', 'RSS', 'hookOnInitTemplate');
        config::setVar('category_page', 1);
        $GLOBALS['_PX_render']['last'] = '';
        $last =& $GLOBALS['_PX_render']['last']; 
        $GLOBALS['_PX_render']['website'] = '';
        $website =& $GLOBALS['_PX_render']['website']; 

        $cache = new Cache(urlencode('rss'));
        $cache->setCacheDirectory(config::getCacheDir());
        $cache->debug = config::f('debug');

        header(FrontEnd::getHeader('rss.rdf'));
        // Load the template
		include config::f('manager_path').'/templates/'
            .config::f('theme_id').'/rss.rdf';
        return 200;
    }

    /**
     * Hook on the initialization of the templates.
     *
     * @param array Default parameters (not used)
     * @return bool Success
     */
    function hookOnInitTemplate($param)
    {
        if (config::f('action') == 'RSS') {
            $GLOBALS['_PX_render']['website'] = FrontEnd::getWebsite();
        }
        return true;
    }

}

?>