<?php
/* -*- tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
# ***** BEGIN LICENSE BLOCK *****
# This file is part of Plume CMS, a website management application.
# Copyright (C) 2001-2005 Loic d'Anterroches and contributors.
#
# Plume CMS is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# Plume CMS is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
# ***** END LICENSE BLOCK ***** */

if (basename($_SERVER['SCRIPT_NAME']) == 'news-edit.php') exit;

/* =================================================== *
 * Preview of the content if some content is available *
 * =================================================== */
if (strlen($news->getUnformattedContent('description'))) {
    echo '<div class="preview">';
    
    echo '<h3>'.$news->getTextContent('title').'</h3>';
    echo $news->getFormattedContent('description','html');

    echo "<hr class='invisible' id=\"xxx-prevent\" /></div>\n\n";
}

/* ================================================= *
 *  If is editable form to modify the content        * 
 * ================================================= */
if ($is_editable) {
    echo '<form action="news.php" method="post" id="formPost" onsubmit="return isReady(\'n_title\',\''.__('You need to give a title.').'\')">';
    echo '<script type="text/javascript">'."\n<!--\n".
        "var js_subtype_ids = new Array('".
        implode("','",$arry_subtypes_extra).
        "');\n//-->\n</script>\n";

    if ($news->cats->nbRow() >= 1) {
        /* ================================================= *
         *  The news is already in a category, propose more  * 
         * ================================================= */
        echo '<fieldset><legend>'. __('Categories')."</legend>\n\n";
        echo "<ol>\n";
        while (!$news->cats->EOF()) {
            echo '<li>'.$news->cats->f('category_name');
            if ($news->cats->f('categoryasso_type') != PX_RESOURCE_CATEGORY_MAIN) {
                echo ' - <a href=\'news.php?delcat=1&amp;resource_id='
                    .$news->f('resource_id').'&amp;n_category_id='
                    .$news->cats->f('category_id').'\' title=\''
                    . __('Remove from this category').'\'>';
                echo '<img src="themes/'.$_px_theme
                    .'/images/delete.png" alt=" "></a> ';
                echo ' <a href=\'news.php?addcategory=main&amp;resource_id='
                    .$news->f('resource_id').'&amp;n_category_id='
                    .$news->cats->f('category_id').'\' title=\''
                    .__('Set as main category').'\'>';
                echo '<img src="themes/'.$_px_theme
                    .'/images/ico_set_as_home.png" alt=" "></a> ';
            } else {
                echo ' - <img src="themes/'.$_px_theme
                    .'/images/ico_home.png" alt="'.__('Main category')
                    .'"></a>';
            }
            echo "</li>\n";
            $news->cats->moveNext();
        }
        echo "</ol>\n\n";
        echo '<p><span class="nowrap"><label for="n_category_id" '
            .'style="display:inline">'.__('Add in another category').' '
            .$m->HelpLink('news', 'h-category').'</label><br />'."\n";
        echo form::combobox('n_category_id',$arry_cat, '', 1)."\n";
        echo '<input name="addcategory" tabindex="2" type="submit" '
            .'class="submit" value="'.__('Add').'" />'."\n";
        echo '</span></p></fieldset>'."\n".'<p>';
    } else {  
        /* ================================================= *
         *  A new news, propose a list of categories         * 
         * ================================================= */
        
        echo '<p>'."\n";
        echo '<span class="nowrap"><label for="n_category_id" '
            .'style="display:inline">'.__('Category').' '
            .$m->HelpLink('news', 'h-category').'</label>'."\n";
        echo form::combobox('n_category_id', $arry_cat, 
                            $news->f('category_id'), 
                            $m->user->getPref('news_category_id'),
                            2).'</span>'."\n";
    } 
    /* ================================================= *
     *  Rest of the edition form                         * 
     * ================================================= */
    
    // content format
    echo '<span class="nowrap"><label for="n_content_format" ';
    echo 'style="display:inline">';
    echo __('Format').' ';  
    echo $m->HelpLink('news', 'h-format'); 
    echo '</label> ';
    echo form::combobox('n_content_format', 
                        array('HTML'=>'html','Wiki'=>'wiki'),
                        $news->getContentFormat('description'), 
                        $m->user->getPref('content_format'), 3);
    echo "</span>\n\n";

    // status
    echo '<span class="nowrap"><label for="n_status" ';
    echo 'style="display:inline">';
    echo __('Status').' '; 
    echo $m->HelpLink('news', 'h-status');
    echo '</label> ';
    echo form::combobox('n_status', $m->getArrayResStatus(), 
                        $news->f('status'), 
                        $m->user->getPref('news_status'), 4);
    echo "</span>\n\n";
    
    // news type, is hidden if only one
    if (count($arry_subtypes) > 1) { 
        echo '<span class="nowrap"><label for="n_subtype" ';
        echo 'style="display:inline">';
        echo __('Type').' '; 
        echo $m->HelpLink('news', 'h-type');
        echo '</label> ';
        echo form::combobox('n_subtype', $arry_subtypes, 
                            $news->f('subtype_id'), '', 5, '',
                            "onChange=\"openCloseBlockIfArray('div_extra','n_subtype',js_subtype_ids,1,-1)\";"); 
        echo "</span></p>\n\n";
    } else {
        echo form::hidden('n_subtype', array_shift($arry_subtypes));
    }

    // title
    echo '<p><label for="n_title"><strong>';
    echo __('Title'); 
    echo '</strong> ';
    echo $m->HelpLink('news', 'h-title'); 
    echo '</label> ';
    echo form::textField('n_title', 30, 255, $news->f('title'), 
                         6, 'style="width:100%"'); 
    echo "</p>\n\n";

    echo "<p>\n";

    // insert image or file
    echo '<span class="bloc-droite"><img src="themes/'.$_px_theme
        .'/images/ico_image.png" alt="" /> ';
    echo '<strong><a href="xmedia.php" accesskey="i" ';
    echo 'onclick="popup(this.href+\'?mode=popup\'); return false;">';
    echo __('Insert an image or a file').'</a></strong></span>'."\n\n";

    // content of the news
    echo '<label for="n_content"><strong>'.__('Content of the news');
    echo '</strong> ';
    echo $m->HelpLink('news', 'h-content'); 
    echo '</label> ';
    echo form::textArea('n_content', 60, 
                        $m->user->getPref('news_textarea_content'), 
                        $news->getUnformattedContent('description'), 7, 
                        'style="width:100%"');

    // size control of the content textarea
    echo '<span class="size-control">'."\n";
    echo '<input type="image" alt="'.__('shrink textarea').'" ';
    echo 'name="decrease" value="-" src="themes/'.$_px_theme
        .'/images/ico_shrink.png" accesskey="-" class="size-control" /> ';
    echo '<input type="image" alt="'.__('grow textarea').'" ';
    echo 'name="increase" value="+" src="themes/'.$_px_theme
        .'/images/ico_grow.png" accesskey="+" class="size-control" /> ';
    echo "</span>\n\n";

    echo "</p>\n\n";

    // keywords
    echo '<p><label for="n_subject">'.__('Keywords').' ';
    echo $m->HelpLink('news', 'h-keywords'); 
    echo '</label>';
    echo form::textArea('n_subject', 60, 4, $news->f('subject'), 8,
                        'style="width:100%"');
    echo "</p>\n";


    // associated website and link
    echo '<div id="div_extra">'."\n";
    echo '<p><label for="n_titlewebsite">'.__('Associated website title').' ';
    echo $m->HelpLink('news', 'h-asso-title');
    echo '</label> ';
    echo form::textField('n_titlewebsite', 50, 255, 
                         $news->details->f('news_titlewebsite'), 9, 
                         'style="width:100%"');
    echo "</p>\n";
    echo '<p><label for="n_linkwebsite">'.__('Associated website address').' ';
    echo $m->HelpLink('news', 'h-asso-address'); 
    echo '</label> ';
    echo form::textField('n_linkwebsite', 50, 255, 
                         $news->details->f('news_linkwebsite'), 10, 
                         'style="width:100%"'); 
    echo '</p></div>'."\n\n";


    // script to show hide the extra part
    echo '<script type="text/javascript">'."\n";
    echo "<!--\n";
    echo "openCloseBlockIfArray('div_extra', 'n_subtype', ";
    echo 'js_subtype_ids, 1, -1);'."\n";
    echo "//-->\n";
    echo '</script>'."\n";



    if ($news->f('resource_id') > 0) {
        echo '<p>'. __('Publication date').' ';
        echo $m->HelpLink('news', 'h-publication-date');
        echo ' '.form::datetime('n_dt', $news->getArrayDate('publicationdate'),
                                11)."<br />\n";
        $noenddate_style = ($news->isDateEOT('enddate')) ? 'style="display: none"' : '';

        echo '<span class="nowrap">'.
            form::checkbox('n_noenddate', 1, $news->isDateEOT('enddate'), 12, 
                           "onclick=\"openCloseSpan('noenddate',0)\"; return false;")
            .' <label for="n_noenddate" style="display:inline">'
            .__('Do not use an expiration date.').'</label></span>'
            .' <span class="nowrap" id="noenddate" '.$noenddate_style
            .'><br />'. __('Expiration date').' ';
        echo $m->HelpLink('news', 'h-expiration-date');
        echo ' '.form::datetime('n_dt_e', $news->getArrayDate('enddate'),
                                13)."</span></p>\n\n";
    }
    
    // submit buttons
    echo "<p>\n";
    echo form::button('submit', 'preview', __('Visualize [v]'), 
                      14, 'v', 'submit');
    echo "&nbsp; \n";
    echo form::button('submit', 'publish', __('Save [s]'), 
                      15, 's', 'submit')."\n";

    if (strlen($news->f('resource_id')) && 
        $news->getContentFormat('description') == 'wiki') {
        echo form::button('submit', 'transform', __('Transform in XHTML'), 
                          16, '', 'submit')."\n";
    }

    if (strlen($news->f('resource_id'))) {
        echo '&nbsp;<input name="delete" type="submit" tabindex="17" class="submit" value="'.__('Delete').'" onclick="return window.confirm(\''.addslashes( __('Are you sure you want to delete this news?')).'\')" />';
        echo form::hidden('resource_id',$news->f('resource_id'));
    }
?></p>
</form>
<h3><a onclick="openClose('wikihelp',0); return false" href="#"><img alt="<?php  echo __('show/hide'); ?>" id="img_wikihelp" src="themes/<?php echo $_px_theme; ?>/images/plus.png" /></a>
<?php  echo __('Wiki syntax'); ?></h3>
<div id="wikihelp" style="display: none;">
<?php echo $m->getHelp('wiki-inline'); ?>
</div>
<script type="text/javascript"><!--
openClose('wikihelp',-1);
//--></script>
  
<?php 
    $px_resource_id = $news->f('resource_id');
    if ($px_resource_id > 0) {
        $ct = $news->comments;
        include dirname(__FILE__).'/comments-rlist.php';
    }
} // end of if ($is_editable) 
?>