<?php 
if ($cache->processPage(180)):
    pxTemplateInit(); 
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<?php pxInfo('encoding'); ?>" />
<meta name="MSSmartTagsPreventParsing" content="TRUE" />
<link rel="schema.DC" href="http://purl.org/dc/elements/1.1/" />
<?php pxHeadLinks(); ?>
<meta name="DC.title" content="<?php pxNewsTitle('%s - '); pxInfo('name'); ?>" />
<link rel="stylesheet" type="text/css" href="<?php pxInfo('filesurl'); ?>theme/default/style.css" media="screen" />
<title><?php pxNewsTitle('%s - '); pxInfo('name'); ?></title>
</head>
<body class="news">

<div id="page">
	<div id="banner">
	<p id="easy-access">
	<a href="#content">Go to content</a> | <a href="#menuleft">Go to menu</a>
	</p>
	<h1 id="top"><?php pxNewsTitle(); ?></h1>
	<h2 id="websitename"><a href="<?php pxInfo('url'); ?>"><?php pxInfo('name'); ?></a></h2>
	</div>

<div id="mainfloat">
	<div id="content">
    <?php pxSingleCatTree('<ol class="tree">%s</ol>'); ?>

    <h2 class="restitle"><?php pxNewsTitle('%s'); ?></h2>
    <div class="news-infos">
		<p class="modified"><a href="<?php pxNewsPath(); ?>">#</a> The <?php pxNewsDateCreation('%Y-%m-%d at %H:%M'); ?>
		by <a href="<?php pxNewsAuthorEmail('mailto:%s'); ?>"><?php pxNewsAuthor(); ?></a>.<?php pxNewsCategories('<br />In %s'); ?>.</p>
    </div>

    <?php pxNewsContent(); ?>

    <?php include dirname(__FILE__).'/comments_inline.php'; ?>

	<hr class="invisible"/>
	</div>

	<div id="menuleft">
		<div class="col-content">
		<h2>BACK TO</h2>
		<ul><li><a href="<?php pxSingleCatPath(); ?>"><?php pxSingleCatTitle('%s'); ?></a></li></ul>

		<?php pxSubCategories('<h2>CATEGORIES</h2> %s'); ?>

		<h2>LINKS</h2>
		<?php pxLink::linkList(); ?>

		</div>
	</div>
</div><!-- end mainfloat -->

<div id="menuright">
	<div class="col-content">

	<h2>SEARCH</h2>

	<form action="<?php pxInfo('url'); ?>search.php" method="get">
	<p><input type="text" name="q" value="" id="q" />
	<input type="submit" value="Search" name="s" id="search-s" /></p>
	</form>

	<h2>MAIN CATEGORIES</h2>
	
	<?php pxPrimaryCategories('<ul id="top-categories">%s</ul>'); ?>

	<p><a href="<?php pxInfo('url'); ?>rss.php">rss 1.0</a></p>

	</div>
</div>

<div id="footer">
	<p>
	<a href="http://www.plume-cms.net/"><img src="<?php pxInfo('filesurl'); ?>theme/default/plume-cms-powered.png" alt="powered by PLUME CMS" /></a>
	</p>
</div>

</div>
</body>

</html>
<?php
    $cache->endCache();
endif;
?>